#-----------------------------------------------------------------------------
#
# Copyright 2019-2020 Sean Baggaley
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its 
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#-----------------------------------------------------------------------------

include(FindPackageHandleStandardArgs)

if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
	set(FMOD_DEB_ARCH "x86")
else()
	set(FMOD_DEB_ARCH "x86_64")
endif()

set(FMOD_DEB_LIBRARY "${CMAKE_SOURCE_DIR}/fmod/api/core/lib/${FMOD_DEB_ARCH}")
set(FMOD_DEB_INCLUDE "${CMAKE_SOURCE_DIR}/fmod/api/core/inc")

find_path(FMOD_INCLUDE_DIR
	NAMES fmod.h
	PATHS "C:/Program Files (x86)/FMOD SoundSystem/FMOD Studio API Windows/api/core/inc" "C:/Program Files/FMOD SoundSystem/FMOD Studio API Windows/api/core/inc" "${FMOD_DEB_INCLUDE}"
	DOC "The path to the directory that contains fmod.h and friends"
)

find_library(FMOD_LIBRARY
	NAMES fmod fmod_vc
	PATHS "C:/Program Files (x86)/FMOD SoundSystem/FMOD Studio API Windows/api/core/lib" "C:/Program Files/FMOD SoundSystem/FMOD Studio API Windows/api/core/lib" "${FMOD_DEB_LIBRARY}"
	DOC "The file that corresponds to the FMOD library."
)

FIND_PACKAGE_HANDLE_STANDARD_ARGS(FMOD DEFAULT_MSG FMOD_INCLUDE_DIR FMOD_LIBRARY)
