//-----------------------------------------------------------------------------
//
// Copyright 2019-2020 Sean Baggaley
// Copyright 1993-1997 id Software
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
// 
// 1. Redistributions of source code must retain the above copyright notice,
//    this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice,
//    this list of conditions and the following disclaimer in the documentation
//    and/or other materials provided with the distribution.
// 
// 3. Neither the name of the copyright holder nor the names of its 
//    contributors may be used to endorse or promote products derived from this
//    software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
//-----------------------------------------------------------------------------

// We are referring to sprite numbers.
#include "info.h"

#include "d_items.h"

//
// PSPRITE ACTIONS for waepons.
// This struct controls the weapon animations.
//
// Each entry is:
//   ammo/amunition type
//  upstate
//  downstate
// readystate
// atkstate, i.e. attack/fire/hit frame
// flashstate, muzzle flash
//
weaponinfo_t weaponinfo[NUMWEAPONS] =
    {
        {// fist
         am_noammo,
         S_PUNCHUP,
         S_PUNCHDOWN,
         S_PUNCH,
         S_PUNCH1,
         S_NULL},
        {// pistol
         am_clip,
         S_PISTOLUP,
         S_PISTOLDOWN,
         S_PISTOL,
         S_PISTOL1,
         S_PISTOLFLASH},
        {// shotgun
         am_shell,
         S_SGUNUP,
         S_SGUNDOWN,
         S_SGUN,
         S_SGUN1,
         S_SGUNFLASH1},
        {// chaingun
         am_clip,
         S_CHAINUP,
         S_CHAINDOWN,
         S_CHAIN,
         S_CHAIN1,
         S_CHAINFLASH1},
        {// missile launcher
         am_misl,
         S_MISSILEUP,
         S_MISSILEDOWN,
         S_MISSILE,
         S_MISSILE1,
         S_MISSILEFLASH1},
        {// plasma rifle
         am_cell,
         S_PLASMAUP,
         S_PLASMADOWN,
         S_PLASMA,
         S_PLASMA1,
         S_PLASMAFLASH1},
        {// bfg 9000
         am_cell,
         S_BFGUP,
         S_BFGDOWN,
         S_BFG,
         S_BFG1,
         S_BFGFLASH1},
        {// chainsaw
         am_noammo,
         S_SAWUP,
         S_SAWDOWN,
         S_SAW,
         S_SAW1,
         S_NULL},
        {// super shotgun
         am_shell,
         S_DSGUNUP,
         S_DSGUNDOWN,
         S_DSGUN,
         S_DSGUN1,
         S_DSGUNFLASH1},
};
